﻿/*
 * This will convert email addresses in the clipboard from the Outlook format, e.g. John Doe <John.Doe@company.com>; "Steve Smith" <Steve.Smith@company.com> to regular emails, e.g. John.Doe@company.com, Steve.Smith@company.com.
 * This code is distributed under the terms of the GNU General Public License.
*/

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace Outlook_Email_Address_Converter
{
    public partial class Form1 : Form
    {
        public string default_text = "[Paste Outlook email addresses here and then click Convert]";
        public Form1()
        {
            InitializeComponent();
        }

        private void btnConvert1_Click(object sender, EventArgs e)
        {
            SaveSettingsToINI();
            string convert_response = Program.ConvertEmails(txtEmails.Text, cmbFirstSeparator.Text, cmbSecondSeparator.Text, false);
            if (convert_response != "error_shown")
            {
                txtEmails.Text = convert_response;
                txtEmails.SelectionStart = 0;
                txtEmails.SelectionLength = txtEmails.Text.Length;
                txtEmails.Focus();
            }
        }

        private void btnExit_Click(object sender, EventArgs e)
        {
            SaveSettingsToINI();
            Application.Exit();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            List<string> separators = new List<string>();
            separators.Add("Comma");
            separators.Add("Semicolon");
            separators.Add("Space");
            separators.Add("New line");
            foreach (string separator in separators)
            {
                cmbFirstSeparator.Items.Add(separator);
                cmbSecondSeparator.Items.Add(separator);
            }
            cmbSecondSeparator.Items.Add("None");
            cmbFirstSeparator.Text = Program.global_first_separator;
            cmbSecondSeparator.Text = Program.global_second_separator;
            txtEmails.Text = default_text;
        }

        private void btnCommandLineParameters_Click(object sender, EventArgs e)
        {

        }

        private void btnRefresh_Click(object sender, EventArgs e)
        {

        }

        private void txtEmails_TextChanged(object sender, EventArgs e)
        {

        }

        private void txtEmails_Enter(object sender, EventArgs e)
        {
            if (txtEmails.Text == default_text)
            {
                txtEmails.SelectionStart = 0;
                txtEmails.SelectionLength = txtEmails.Text.Length;
            }
        }

        private void txtEmails_Click(object sender, EventArgs e)
        {
            if (txtEmails.Text == default_text)
            {
                txtEmails.SelectionStart = 0;
                txtEmails.SelectionLength = txtEmails.Text.Length;
            }
        }

        private void cmbFirstSeparator_SelectedIndexChanged(object sender, EventArgs e)
        {
            
        }

        private void SaveSettingsToINI()
        {
            int return_val = Program.WriteINI("settings", "first_separator", cmbFirstSeparator.Text, Program.SettingsINI);
            if (return_val == 0)
            {
                MessageBox.Show("An error occurred while writing to the " + Program.SettingsINI + " file. Please make sure that you have write permission to this directory in Windows.");
            }
            Program.WriteINI("settings", "second_separator", cmbSecondSeparator.Text, Program.SettingsINI);
        }
    }
}
